;LCD
RST	BIT	P0.0
RS	BIT	P0.1
RW	BIT	P0.2
EN	BIT	P0.3

;DS18B20
DQ	BIT	P0.4

;߼ʿ
BZ	BIT	P0.5

FLAG1      BIT  00H  ; 20HԪеλ

;LCDز
SONG	EQU	20H
READ	EQU	21H
XUNHUAN	EQU	22H
COUNT	EQU	23H

;DS18B20ز
TEMPER_L  EQU	36H
TEMPER_H  EQU	35H
TEMPER     EQU  34H  ; ת8λ¶ֵ

;ű¶
TEMP	EQU	37H
	
;嵥Ԫ
TEMPER_NUM	EQU	60H

;*******************************
	ORG	0000H
	LJMP	START

	;ⲿж0
	ORG	0003H
	LJMP	INT0_ISR

	;ⲿж1
	ORG	0013H
	LJMP	INT1_ISR

	ORG	0030H
START:  MOV	SP,#70H
	MOV	TCON,#05H
	CLR	RST
	LCALL	DELAY
	SETB	RST
	LCALL	ST12864_INT
	MOV	TEMP,#21

	;жĴ
	SETB	EX0
	SETB	EX1
	SETB	EA

	;ѭ
MAIN_LOOP:
	LCALL	GET_TEMPER
	LCALL	TEMPER_COV
	MOV	A,TEMPER_NUM
	CJNE	A,TEMP,TEMP_COMPARE
	SJMP    TEMP_EQUAL   

TEMP_COMPARE:

	JNC TEMP_ABOVE      ; C=0תTEMP_ABOVE
    	SJMP TEMP_BELOW     ; C=1תTEMP_BELOW

    ; ¶ȵ趨ֵ߼
TEMP_EQUAL:
	SETB BZ              ; 
	SJMP TEMP_COMPARE_END

TEMP_ABOVE:
    ; ¶ȸ趨ֵ߼
	SETB BZ             ; ñ־λ
	SJMP TEMP_COMPARE_END

TEMP_BELOW:
    ; ¶ȵ趨ֵ߼
	CLR BZ              ; ־λ
	;SJMP TEMP_COMPARE_END	

TEMP_COMPARE_END:
	LCALL	HANZI_WRITE
	LCALL	MOTOR
	SJMP	MAIN_LOOP

	;ⲿж0
INT0_ISR:
	PUSH	ACC
	PUSH	PSW

	;¶
	INC	TEMP

	;LCDʾ
	;LCALL	HANZI_WRITE

	POP	PSW
	POP	ACC
	RETI

	;ⲿж1
INT1_ISR:
	PUSH	ACC
	PUSH	PSW

	;¶
	DEC	TEMP

	;LCDʾ
	;LCALL	HANZI_WRITE

	POP	PSW
	POP	ACC
	RETI
	
TABLE:	DB	"ѧ"
	DB	"250418"
	DB	"¶: "
	DB	": "

	;ʱ
DELAY:	PUSH	00H
	PUSH	01H
	MOV	R0,#00H
DELAY1: MOV	R1,#00H
	DJNZ	R1,$
	DJNZ	R0,DELAY1
	POP	01H
	POP	00H
	RET

;*********************************************************************

;ģʼ
ST12864_INT:                
    	MOV SONG,#30H       ;ָĿ֣00110000B
    	LCALL SEND_ML

    	MOV SONG,#01H       ;ʾĻ
    	;DDRAM20HոASCII룬AC=00H
    	LCALL SEND_ML
    	MOV SONG,#06H       ;趨㡱ָ֣AC+1ͼβƶƶ
    	LCALL SEND_ML
    	MOV SONG,#0CH       ;0CHǡʾ״ָ̬֣ʾ޹꣬޷
    	LCALL SEND_ML
    	RET

;*********************************************************************

 ;ӳ
SEND_ML:                  
    	LCALL CHK_BUSY      ;֮ǰӦ12864Ƿæ
    	MOV P2,SONG         ;ָ12864ݿ
    	CLR RS
    	CLR RW
    	SETB EN             ;Ҫд
    	LCALL DELAY
    	CLR EN
    	RET

;************

;ѯ״̬ӳ

CHK_BUSY:
    	MOV P2, #0FFH ;ø׼λ
    	CLR RS
    	SETB RW      ;æź
    	SETB EN
LOOP:   MOV A, P2    ;æź
    	JB P2.7, LOOP ;P2.7=1æȴ
    	CLR EN
    	RET

;************

;дӳ

HANZI_WRITE:
    	MOV	SONG, #80H    ;趨 DDRAM ַ1УAC=0
    	LCALL 	SEND_ML ;͵ַ
	MOV	XUNHUAN,#12
    	MOV 	DPTR, #TABLE 
	MOV	A,#00H
    	MOV 	COUNT, #00H

LOOP1: 	MOV	A,COUNT
	MOVC A, @A+DPTR
    	MOV SONG, A
    	LCALL SEND_SJ
	INC	COUNT
	;MOV A, COUNT
    	DJNZ XUNHUAN, LOOP1

	;дڶ
	MOV	SONG,#90H
	LCALL	SEND_ML
	MOV	XUNHUAN,#12
	MOV	COUNT,#12
LOOP2:  MOV	A,COUNT
	MOVC	A,@A+DPTR
	MOV	SONG,A
	LCALL	SEND_SJ
	INC	COUNT
	DJNZ	XUNHUAN,LOOP2

	;д
	MOV	SONG,#88H
	LCALL	SEND_ML
	MOV	XUNHUAN,#6
	MOV	COUNT,#24;ӵ25ֽڿʼ
LOOP3:
	MOV	A,COUNT
	MOVC	A,@A+DPTR
	CJNE	A,#' ',WRITE_TEMP
	
	;òʾ
	LCALL	INSERT_VARIABLE
	;INC	COUNT
	;INC	COUNT
	SJMP	NEXT_CHAR

WRITE_TEMP:
	MOV	SONG,A
	LCALL	SEND_SJ
NEXT_CHAR:
	INC	COUNT
	DJNZ	XUNHUAN,LOOP3

	;д
	MOV	SONG,#98H
	LCALL	SEND_ML
	MOV	XUNHUAN,#6
	MOV	COUNT,#30;ӵ31ֽڿʼ
LOOP4:
	MOV	A,COUNT
	MOVC	A,@A+DPTR
	CJNE	A,#' ',WRITE_TEMP_LIMIT
	LCALL	DISPLAY_TEMP_LIMIT
	SJMP	NEXT_CHAR4

WRITE_TEMP_LIMIT:
	MOV	SONG,A
	LCALL	SEND_SJ

NEXT_CHAR4:
	INC	COUNT
	DJNZ	XUNHUAN,LOOP4
	RET

INSERT_VARIABLE:
	MOV	A,TEMPER_NUM
	MOV	B,#10
	DIV	AB
	ADD	A,#30H
	MOV	SONG,A
	LCALL	SEND_SJ
	MOV	A,B
	ADD	A,#30H
	MOV	SONG,A
	LCALL	SEND_SJ
	RET

DISPLAY_TEMP_LIMIT:
	MOV	A,TEMP
	MOV	B,#10
	DIV	AB
	ADD	A,#30H
	MOV	SONG,A
	LCALL	SEND_SJ
	MOV	A,B
	ADD	A,#30H
	MOV	SONG,A
	LCALL	SEND_SJ
	RET

;************

;ӳ

SEND_SJ:
    LCALL CHK_BUSY
    MOV P2, SONG
    SETB RS
    CLR RW
    SETB EN
    CLR EN
    RET
    
; ¶Ȳɼӳ
GET_TEMPER:          
    SETB  DQ        
BCD:
    LCALL  INIT_1820  
    JB     FLAG1, S22 
    LJMP  BCD        
S22:  
    LCALL  DELAY_1   
    MOV   A, #0CCH   
    LCALL  WRITE_1820 
    MOV   A, #44H    
    LCALL  WRITE_1820 
    LCALL  DELAY     
CBA:  
    LCALL  INIT_1820  
    JB    FLAG1, ABC 
    LJMP  CBA        
ABC:  
    LCALL  DELAY_1   
    MOV   A, #0CCH   
    LCALL  WRITE_1820 
    MOV   A, #0BEH   
    LCALL  WRITE_1820 
    LCALL  READ_1820  
    RET               

WRITE_1820:          
    MOV   R2, #8     
    CLR   C         
WR1:   
    CLR   DQ      
    MOV   R3, #7  
    DJNZ  R3, $   
    RRC   A       
    MOV   DQ, C   
    MOV   R3, #15H 
    DJNZ  R3, $   
    SETB  DQ      
    NOP           
    DJNZ  R2, WR1 
    SETB  DQ      
    RET           

READ_1820:          
    PUSH  02H        
    PUSH  04H        
    MOV   R4, #2        
    MOV   R1, #36H      
RE00: 
    MOV   R2, #8     
RE01:
    CLR   C          
    SETB  DQ        
    NOP             
    CLR   DQ        
    NOP             
    NOP
    NOP
    NOP
    NOP             
    SETB  DQ        
    MOV   R3, #5     
    DJNZ  R3, $
    MOV   C, DQ      
    MOV   R3, #1CH   
    DJNZ  R3, $
    RRC   A          
    DJNZ  R2, RE01  
    MOV   @R1, A     
    DEC   R1         
    DJNZ  R4, RE00  
    POP   04H        
    POP   02H        
    RET             

TEMPER_COV:
    MOV   A, #0F0H    
    ANL   A, TEMPER_L 
    SWAP  A           
    MOV   TEMPER_NUM, A 
    MOV   A, TEMPER_L  
    JNB   ACC.3, TEMPER_COV1 
    INC   TEMPER_NUM    
TEMPER_COV1:
    MOV   A, TEMPER_H  
    ANL   A, #07H      
    SWAP  A            
    ADD   A, TEMPER_NUM 
    MOV   TEMPER_NUM, A 
    MOV   TEMPER, TEMPER_NUM 
    RET                 

INIT_1820:                
    SETB  DQ           
    NOP                
    CLR   DQ           
    MOV   R0, #0ECH    
TSR1: 
    DJNZ  R0, TSR1    
    SETB  DQ           
    MOV   R0, #1CH     
TSR2: 
    DJNZ  R0, TSR2    
    JNB   DQ, TSR3     
    LJMP  TSR4         
TSR3: 
    SETB  FLAG1      
    LJMP  TSR5         
TSR4: 
    CLR   FLAG1      
    LJMP  TSR7         
TSR5: 
    MOV   R0, #0E0H  
TSR6: 
    DJNZ  R0, TSR6   
TSR7: 
    SETB  DQ         
    RET                
DELAY_1: 
    MOV   R7, #20H 
    DJNZ   R7, $         
    RET      

;ӳ
MOTOR:
    JNB   P0.5,DIRECT
    MOV	  P1,#05H
    LCALL DELAY1
    SJMP  EXIT
DIRECT:
    MOV   P1,#00H
    LCALL DELAY1
EXIT:
    RET
    END
